/* minefield.c generated by valac 0.32.0.61-f103e, the Vala compiler
 * generated from minefield.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_FLAG_TYPE (flag_type_get_type ())

#define TYPE_LOCATION (location_get_type ())
#define LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCATION, Location))
#define LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOCATION, LocationClass))
#define IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCATION))
#define IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOCATION))
#define LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOCATION, LocationClass))

typedef struct _Location Location;
typedef struct _LocationClass LocationClass;
typedef struct _LocationPrivate LocationPrivate;

#define TYPE_NEIGHBOUR (neighbour_get_type ())
typedef struct _Neighbour Neighbour;

#define TYPE_MINEFIELD (minefield_get_type ())
#define MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINEFIELD, Minefield))
#define MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINEFIELD, MinefieldClass))
#define IS_MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINEFIELD))
#define IS_MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINEFIELD))
#define MINEFIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINEFIELD, MinefieldClass))

typedef struct _Minefield Minefield;
typedef struct _MinefieldClass MinefieldClass;
typedef struct _MinefieldPrivate MinefieldPrivate;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	FLAG_TYPE_NONE,
	FLAG_TYPE_FLAG,
	FLAG_TYPE_MAYBE
} FlagType;

struct _Location {
	GObject parent_instance;
	LocationPrivate * priv;
	gboolean has_mine;
	gboolean cleared;
	FlagType flag;
};

struct _LocationClass {
	GObjectClass parent_class;
};

struct _Neighbour {
	gint x;
	gint y;
};

struct _Minefield {
	GObject parent_instance;
	MinefieldPrivate * priv;
	guint width;
	guint height;
	guint n_mines;
	Location** locations;
	gint locations_length1;
	gint locations_length2;
	gboolean exploded;
	gboolean placed_mines;
	gboolean _use_autoflag;
};

struct _MinefieldClass {
	GObjectClass parent_class;
};

struct _MinefieldPrivate {
	guint _n_cleared;
	guint _n_flags;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};


static gpointer location_parent_class = NULL;
static gpointer minefield_parent_class = NULL;

GType flag_type_get_type (void) G_GNUC_CONST;
GType location_get_type (void) G_GNUC_CONST;
enum  {
	LOCATION_DUMMY_PROPERTY
};
Location* location_new (void);
Location* location_construct (GType object_type);
static void location_finalize (GObject* obj);
GType neighbour_get_type (void) G_GNUC_CONST;
Neighbour* neighbour_dup (const Neighbour* self);
void neighbour_free (Neighbour* self);
GType minefield_get_type (void) G_GNUC_CONST;
#define MINEFIELD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MINEFIELD, MinefieldPrivate))
enum  {
	MINEFIELD_DUMMY_PROPERTY,
	MINEFIELD_N_CLEARED,
	MINEFIELD_IS_COMPLETE,
	MINEFIELD_N_FLAGS,
	MINEFIELD_USE_AUTOFLAG,
	MINEFIELD_ELAPSED,
	MINEFIELD_PAUSED
};
Minefield* minefield_new (guint width, guint height, guint n_mines);
Minefield* minefield_construct (GType object_type, guint width, guint height, guint n_mines);
gboolean minefield_is_clock_started (Minefield* self);
gdouble minefield_get_elapsed (Minefield* self);
gboolean minefield_has_mine (Minefield* self, guint x, guint y);
gboolean minefield_is_cleared (Minefield* self, guint x, guint y);
gboolean minefield_is_location (Minefield* self, gint x, gint y);
void minefield_multi_release (Minefield* self, guint x, guint y);
FlagType minefield_get_flag (Minefield* self, guint x, guint y);
guint minefield_get_n_adjacent_mines (Minefield* self, guint x, guint y);
gboolean minefield_get_use_autoflag (Minefield* self);
void minefield_clear_mine (Minefield* self, guint x, guint y);
void minefield_set_flag (Minefield* self, guint x, guint y, FlagType flag);
static void minefield_start_clock (Minefield* self);
static void minefield_place_mines (Minefield* self, guint x, guint y);
static void minefield_clear_mines_recursive (Minefield* self, guint x, guint y);
static void minefield_stop_clock (Minefield* self);
gboolean minefield_get_is_complete (Minefield* self);
guint minefield_get_n_cleared (Minefield* self);
void minefield_set_n_cleared (Minefield* self, guint value);
guint minefield_get_n_flags (Minefield* self);
void minefield_set_n_flags (Minefield* self, guint value);
gboolean minefield_has_flag_warning (Minefield* self, guint x, guint y);
static void minefield_start_timer (Minefield* self);
static gboolean minefield_timeout_cb (Minefield* self);
static gboolean _minefield_timeout_cb_gsource_func (gpointer self);
static void minefield_continue_clock (Minefield* self);
void minefield_set_use_autoflag (Minefield* self, gboolean value);
gboolean minefield_get_paused (Minefield* self);
void minefield_set_paused (Minefield* self, gboolean value);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void minefield_finalize (GObject* obj);
static void _vala_minefield_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_minefield_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

const Neighbour neighbour_map[8] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

GType flag_type_get_type (void) {
	static volatile gsize flag_type_type_id__volatile = 0;
	if (g_once_init_enter (&flag_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FLAG_TYPE_NONE, "FLAG_TYPE_NONE", "none"}, {FLAG_TYPE_FLAG, "FLAG_TYPE_FLAG", "flag"}, {FLAG_TYPE_MAYBE, "FLAG_TYPE_MAYBE", "maybe"}, {0, NULL, NULL}};
		GType flag_type_type_id;
		flag_type_type_id = g_enum_register_static ("FlagType", values);
		g_once_init_leave (&flag_type_type_id__volatile, flag_type_type_id);
	}
	return flag_type_type_id__volatile;
}


Location* location_construct (GType object_type) {
	Location * self = NULL;
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self = (Location*) g_object_new (object_type, NULL);
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return self;
#line 184 "minefield.c"
}


Location* location_new (void) {
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return location_construct (TYPE_LOCATION);
#line 191 "minefield.c"
}


static void location_class_init (LocationClass * klass) {
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	location_parent_class = g_type_class_peek_parent (klass);
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = location_finalize;
#line 200 "minefield.c"
}


static void location_instance_init (Location * self) {
#line 21 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->has_mine = FALSE;
#line 24 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->cleared = FALSE;
#line 27 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->flag = FLAG_TYPE_NONE;
#line 211 "minefield.c"
}


static void location_finalize (GObject* obj) {
	Location * self;
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOCATION, Location);
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (location_parent_class)->finalize (obj);
#line 221 "minefield.c"
}


GType location_get_type (void) {
	static volatile gsize location_type_id__volatile = 0;
	if (g_once_init_enter (&location_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Location), 0, (GInstanceInitFunc) location_instance_init, NULL };
		GType location_type_id;
		location_type_id = g_type_register_static (G_TYPE_OBJECT, "Location", &g_define_type_info, 0);
		g_once_init_leave (&location_type_id__volatile, location_type_id);
	}
	return location_type_id__volatile;
}


Neighbour* neighbour_dup (const Neighbour* self) {
	Neighbour* dup;
#line 31 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	dup = g_new0 (Neighbour, 1);
#line 31 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	memcpy (dup, self, sizeof (Neighbour));
#line 31 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return dup;
#line 245 "minefield.c"
}


void neighbour_free (Neighbour* self) {
#line 31 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_free (self);
#line 252 "minefield.c"
}


GType neighbour_get_type (void) {
	static volatile gsize neighbour_type_id__volatile = 0;
	if (g_once_init_enter (&neighbour_type_id__volatile)) {
		GType neighbour_type_id;
		neighbour_type_id = g_boxed_type_register_static ("Neighbour", (GBoxedCopyFunc) neighbour_dup, (GBoxedFreeFunc) neighbour_free);
		g_once_init_leave (&neighbour_type_id__volatile, neighbour_type_id);
	}
	return neighbour_type_id__volatile;
}


Minefield* minefield_construct (GType object_type, guint width, guint height, guint n_mines) {
	Minefield * self = NULL;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	Location** _tmp2_ = NULL;
	guint _tmp16_ = 0U;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
#line 137 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self = (Minefield*) g_object_new (object_type, NULL);
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = width;
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = height;
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = g_new0 (Location*, (_tmp0_ * _tmp1_) + 1);
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->locations = _tmp2_;
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->locations_length1 = _tmp0_;
#line 139 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->locations_length2 = _tmp1_;
#line 291 "minefield.c"
	{
		gint x = 0;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		x = 0;
#line 296 "minefield.c"
		{
			gboolean _tmp3_ = FALSE;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp3_ = TRUE;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			while (TRUE) {
#line 303 "minefield.c"
				gint _tmp5_ = 0;
				guint _tmp6_ = 0U;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp3_) {
#line 308 "minefield.c"
					gint _tmp4_ = 0;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp4_ = x;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					x = _tmp4_ + 1;
#line 314 "minefield.c"
				}
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp3_ = FALSE;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp5_ = x;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp6_ = width;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!(((guint) _tmp5_) < _tmp6_)) {
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					break;
#line 326 "minefield.c"
				}
				{
					gint y = 0;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					y = 0;
#line 332 "minefield.c"
					{
						gboolean _tmp7_ = FALSE;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp7_ = TRUE;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						while (TRUE) {
#line 339 "minefield.c"
							gint _tmp9_ = 0;
							guint _tmp10_ = 0U;
							Location** _tmp11_ = NULL;
							gint _tmp11__length1 = 0;
							gint _tmp11__length2 = 0;
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							Location* _tmp14_ = NULL;
							Location* _tmp15_ = NULL;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							if (!_tmp7_) {
#line 351 "minefield.c"
								gint _tmp8_ = 0;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp8_ = y;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								y = _tmp8_ + 1;
#line 357 "minefield.c"
							}
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp7_ = FALSE;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp9_ = y;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp10_ = height;
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							if (!(((guint) _tmp9_) < _tmp10_)) {
#line 141 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								break;
#line 369 "minefield.c"
							}
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp11_ = self->locations;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp11__length1 = self->locations_length1;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp11__length2 = self->locations_length2;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp12_ = x;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp13_ = y;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp14_ = location_new ();
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_g_object_unref0 (_tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_]);
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_] = _tmp14_;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp15_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
#line 389 "minefield.c"
						}
					}
				}
			}
		}
	}
#line 143 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp16_ = width;
#line 143 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->width = _tmp16_;
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp17_ = height;
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->height = _tmp17_;
#line 145 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp18_ = n_mines;
#line 145 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->n_mines = _tmp18_;
#line 137 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return self;
#line 410 "minefield.c"
}


Minefield* minefield_new (guint width, guint height, guint n_mines) {
#line 137 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return minefield_construct (TYPE_MINEFIELD, width, height, n_mines);
#line 417 "minefield.c"
}


gboolean minefield_is_clock_started (Minefield* self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 148 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = minefield_get_elapsed (self);
#line 150 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 150 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp1_ > ((gdouble) 0);
#line 150 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 435 "minefield.c"
}


gboolean minefield_has_mine (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 153 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->locations;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->has_mine;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 155 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 468 "minefield.c"
}


gboolean minefield_is_cleared (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 158 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->locations;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->cleared;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 501 "minefield.c"
}


gboolean minefield_is_location (Minefield* self, gint x, gint y) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
#line 163 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = x;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp3_ >= 0) {
#line 517 "minefield.c"
		gint _tmp4_ = 0;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp4_ = y;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp2_ = _tmp4_ >= 0;
#line 523 "minefield.c"
	} else {
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp2_ = FALSE;
#line 527 "minefield.c"
	}
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp2_) {
#line 531 "minefield.c"
		gint _tmp5_ = 0;
		guint _tmp6_ = 0U;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp5_ = x;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = self->width;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp1_ = ((guint) _tmp5_) < _tmp6_;
#line 540 "minefield.c"
	} else {
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp1_ = FALSE;
#line 544 "minefield.c"
	}
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp1_) {
#line 548 "minefield.c"
		gint _tmp7_ = 0;
		guint _tmp8_ = 0U;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp7_ = y;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp8_ = self->height;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = ((guint) _tmp7_) < _tmp8_;
#line 557 "minefield.c"
	} else {
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = FALSE;
#line 561 "minefield.c"
	}
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 567 "minefield.c"
}


void minefield_multi_release (Minefield* self, guint x, guint y) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	gboolean _tmp3_ = FALSE;
	guint n_mines = 0U;
	guint _tmp7_ = 0U;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	guint n_flags = 0U;
	guint n_unknown = 0U;
	gboolean do_clear = FALSE;
	guint _tmp27_ = 0U;
	guint _tmp28_ = 0U;
#line 168 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = minefield_is_cleared (self, _tmp1_, _tmp2_);
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (!_tmp3_) {
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = TRUE;
#line 597 "minefield.c"
	} else {
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
		FlagType _tmp6_ = 0;
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp4_ = x;
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp5_ = y;
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = minefield_get_flag (self, _tmp4_, _tmp5_);
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp6_ == FLAG_TYPE_FLAG;
#line 610 "minefield.c"
	}
#line 170 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 171 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 616 "minefield.c"
	}
#line 174 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp7_ = x;
#line 174 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp8_ = y;
#line 174 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp9_ = minefield_get_n_adjacent_mines (self, _tmp7_, _tmp8_);
#line 174 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n_mines = _tmp9_;
#line 175 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n_flags = (guint) 0;
#line 176 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n_unknown = (guint) 0;
#line 630 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 177 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 177 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 177 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 642 "minefield.c"
			Neighbour neighbour = {0};
#line 177 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 646 "minefield.c"
			{
				gint nx = 0;
				guint _tmp10_ = 0U;
				Neighbour _tmp11_ = {0};
				gint _tmp12_ = 0;
				gint ny = 0;
				guint _tmp13_ = 0U;
				Neighbour _tmp14_ = {0};
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				gboolean _tmp18_ = FALSE;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				FlagType _tmp21_ = 0;
				gint _tmp23_ = 0;
				gint _tmp24_ = 0;
				gboolean _tmp25_ = FALSE;
#line 179 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp10_ = x;
#line 179 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp11_ = neighbour;
#line 179 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp12_ = _tmp11_.x;
#line 179 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp10_) + _tmp12_;
#line 180 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp13_ = y;
#line 180 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp14_ = neighbour;
#line 180 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp15_ = _tmp14_.y;
#line 180 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp13_) + _tmp15_;
#line 181 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp16_ = nx;
#line 181 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp17_ = ny;
#line 181 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp18_ = minefield_is_location (self, _tmp16_, _tmp17_);
#line 181 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp18_) {
#line 182 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					continue;
#line 691 "minefield.c"
				}
#line 183 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp19_ = nx;
#line 183 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp20_ = ny;
#line 183 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp21_ = minefield_get_flag (self, (guint) _tmp19_, (guint) _tmp20_);
#line 183 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp21_ == FLAG_TYPE_FLAG) {
#line 701 "minefield.c"
					guint _tmp22_ = 0U;
#line 184 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp22_ = n_flags;
#line 184 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					n_flags = _tmp22_ + 1;
#line 707 "minefield.c"
				}
#line 185 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp23_ = nx;
#line 185 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp24_ = ny;
#line 185 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp25_ = minefield_is_cleared (self, (guint) _tmp23_, (guint) _tmp24_);
#line 185 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp25_) {
#line 717 "minefield.c"
					guint _tmp26_ = 0U;
#line 186 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp26_ = n_unknown;
#line 186 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					n_unknown = _tmp26_ + 1;
#line 723 "minefield.c"
				}
			}
		}
	}
#line 192 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	do_clear = FALSE;
#line 193 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp27_ = n_mines;
#line 193 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp28_ = n_flags;
#line 193 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp27_ == _tmp28_) {
#line 194 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		do_clear = TRUE;
#line 738 "minefield.c"
	} else {
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_ = FALSE;
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp30_ = minefield_get_use_autoflag (self);
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp31_ = _tmp30_;
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (_tmp31_) {
#line 749 "minefield.c"
			guint _tmp32_ = 0U;
			guint _tmp33_ = 0U;
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp32_ = n_unknown;
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp33_ = n_mines;
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp29_ = _tmp32_ == _tmp33_;
#line 758 "minefield.c"
		} else {
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp29_ = FALSE;
#line 762 "minefield.c"
		}
#line 195 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (_tmp29_) {
#line 196 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			do_clear = FALSE;
#line 768 "minefield.c"
		} else {
#line 198 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			return;
#line 772 "minefield.c"
		}
	}
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 202 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 202 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 202 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 786 "minefield.c"
			Neighbour neighbour = {0};
#line 202 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 790 "minefield.c"
			{
				gint nx = 0;
				guint _tmp34_ = 0U;
				Neighbour _tmp35_ = {0};
				gint _tmp36_ = 0;
				gint ny = 0;
				guint _tmp37_ = 0U;
				Neighbour _tmp38_ = {0};
				gint _tmp39_ = 0;
				gint _tmp40_ = 0;
				gint _tmp41_ = 0;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_ = FALSE;
				gboolean _tmp44_ = FALSE;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp34_ = x;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp35_ = neighbour;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp36_ = _tmp35_.x;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp34_) + _tmp36_;
#line 205 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp37_ = y;
#line 205 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp38_ = neighbour;
#line 205 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp39_ = _tmp38_.y;
#line 205 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp37_) + _tmp39_;
#line 206 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp40_ = nx;
#line 206 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp41_ = ny;
#line 206 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp42_ = minefield_is_location (self, _tmp40_, _tmp41_);
#line 206 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp42_) {
#line 207 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					continue;
#line 831 "minefield.c"
				}
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp44_ = do_clear;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp44_) {
#line 837 "minefield.c"
					gint _tmp45_ = 0;
					gint _tmp46_ = 0;
					FlagType _tmp47_ = 0;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp45_ = nx;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp46_ = ny;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp47_ = minefield_get_flag (self, (guint) _tmp45_, (guint) _tmp46_);
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp43_ = _tmp47_ != FLAG_TYPE_FLAG;
#line 849 "minefield.c"
				} else {
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp43_ = FALSE;
#line 853 "minefield.c"
				}
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp43_) {
#line 857 "minefield.c"
					gint _tmp48_ = 0;
					gint _tmp49_ = 0;
#line 210 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp48_ = nx;
#line 210 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp49_ = ny;
#line 210 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					minefield_clear_mine (self, (guint) _tmp48_, (guint) _tmp49_);
#line 866 "minefield.c"
				} else {
					gint _tmp50_ = 0;
					gint _tmp51_ = 0;
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp50_ = nx;
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp51_ = ny;
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					minefield_set_flag (self, (guint) _tmp50_, (guint) _tmp51_, FLAG_TYPE_FLAG);
#line 876 "minefield.c"
				}
			}
		}
	}
}


void minefield_clear_mine (Minefield* self, guint x, guint y) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_ = FALSE;
	Location** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gint _tmp7__length2 = 0;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	Location* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
	Location** _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gint _tmp19__length2 = 0;
	guint _tmp20_ = 0U;
	guint _tmp21_ = 0U;
	Location* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
#line 216 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = self->exploded;
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (!_tmp1_) {
#line 913 "minefield.c"
		GTimer* _tmp2_ = NULL;
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 919 "minefield.c"
	} else {
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = FALSE;
#line 923 "minefield.c"
	}
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 219 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_start_clock (self);
#line 929 "minefield.c"
	}
#line 222 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = self->placed_mines;
#line 222 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (!_tmp3_) {
#line 935 "minefield.c"
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
#line 224 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp4_ = x;
#line 224 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp5_ = y;
#line 224 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_place_mines (self, _tmp4_, _tmp5_);
#line 225 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		self->placed_mines = TRUE;
#line 946 "minefield.c"
	}
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp7_ = self->locations;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp7__length1 = self->locations_length1;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp7__length2 = self->locations_length2;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp8_ = x;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp9_ = y;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp10_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp11_ = _tmp10_->cleared;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp11_) {
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = TRUE;
#line 966 "minefield.c"
	} else {
		Location** _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		gint _tmp12__length2 = 0;
		guint _tmp13_ = 0U;
		guint _tmp14_ = 0U;
		Location* _tmp15_ = NULL;
		FlagType _tmp16_ = 0;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp12_ = self->locations;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp12__length1 = self->locations_length1;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp12__length2 = self->locations_length2;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp13_ = x;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp14_ = y;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp16_ = _tmp15_->flag;
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = _tmp16_ == FLAG_TYPE_FLAG;
#line 991 "minefield.c"
	}
#line 228 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp6_) {
#line 229 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 997 "minefield.c"
	}
#line 231 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp17_ = x;
#line 231 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp18_ = y;
#line 231 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	minefield_clear_mines_recursive (self, _tmp17_, _tmp18_);
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp19_ = self->locations;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp19__length1 = self->locations_length1;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp19__length2 = self->locations_length2;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp20_ = x;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp21_ = y;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp22_ = _tmp19_[(_tmp20_ * _tmp19__length2) + _tmp21_];
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp23_ = _tmp22_->has_mine;
#line 234 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp23_) {
#line 1021 "minefield.c"
		gboolean _tmp24_ = FALSE;
#line 236 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp24_ = self->exploded;
#line 236 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (!_tmp24_) {
#line 238 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			self->exploded = TRUE;
#line 239 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			minefield_stop_clock (self);
#line 240 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			g_signal_emit_by_name (self, "explode");
#line 1033 "minefield.c"
		}
#line 242 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 1037 "minefield.c"
	}
#line 246 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25_ = minefield_get_is_complete (self);
#line 246 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp26_ = _tmp25_;
#line 246 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp26_) {
#line 248 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_stop_clock (self);
#line 1047 "minefield.c"
		{
			gint tx = 0;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			tx = 0;
#line 1052 "minefield.c"
			{
				gboolean _tmp27_ = FALSE;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp27_ = TRUE;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				while (TRUE) {
#line 1059 "minefield.c"
					gint _tmp29_ = 0;
					guint _tmp30_ = 0U;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					if (!_tmp27_) {
#line 1064 "minefield.c"
						gint _tmp28_ = 0;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp28_ = tx;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						tx = _tmp28_ + 1;
#line 1070 "minefield.c"
					}
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp27_ = FALSE;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp29_ = tx;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp30_ = self->width;
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					if (!(((guint) _tmp29_) < _tmp30_)) {
#line 249 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						break;
#line 1082 "minefield.c"
					}
					{
						gint ty = 0;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						ty = 0;
#line 1088 "minefield.c"
						{
							gboolean _tmp31_ = FALSE;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							_tmp31_ = TRUE;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							while (TRUE) {
#line 1095 "minefield.c"
								gint _tmp33_ = 0;
								guint _tmp34_ = 0U;
								gint _tmp35_ = 0;
								gint _tmp36_ = 0;
								gboolean _tmp37_ = FALSE;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								if (!_tmp31_) {
#line 1103 "minefield.c"
									gint _tmp32_ = 0;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp32_ = ty;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									ty = _tmp32_ + 1;
#line 1109 "minefield.c"
								}
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp31_ = FALSE;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp33_ = ty;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp34_ = self->height;
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								if (!(((guint) _tmp33_) < _tmp34_)) {
#line 250 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									break;
#line 1121 "minefield.c"
								}
#line 251 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp35_ = tx;
#line 251 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp36_ = ty;
#line 251 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp37_ = minefield_has_mine (self, (guint) _tmp35_, (guint) _tmp36_);
#line 251 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								if (_tmp37_) {
#line 1131 "minefield.c"
									gint _tmp38_ = 0;
									gint _tmp39_ = 0;
#line 252 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp38_ = tx;
#line 252 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp39_ = ty;
#line 252 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									minefield_set_flag (self, (guint) _tmp38_, (guint) _tmp39_, FLAG_TYPE_FLAG);
#line 1140 "minefield.c"
								}
							}
						}
					}
				}
			}
		}
#line 253 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_signal_emit_by_name (self, "cleared");
#line 1150 "minefield.c"
	}
}


static void minefield_clear_mines_recursive (Minefield* self, guint x, guint y) {
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	Location** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint _tmp5__length2 = 0;
	guint _tmp6_ = 0U;
	guint _tmp7_ = 0U;
	Location* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	guint _tmp10_ = 0U;
	Location** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gint _tmp11__length2 = 0;
	guint _tmp12_ = 0U;
	guint _tmp13_ = 0U;
	Location* _tmp14_ = NULL;
	FlagType _tmp15_ = 0;
	Location** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gint _tmp18__length2 = 0;
	guint _tmp19_ = 0U;
	guint _tmp20_ = 0U;
	Location* _tmp21_ = NULL;
	guint _tmp22_ = 0U;
	guint _tmp23_ = 0U;
	gboolean _tmp24_ = FALSE;
	Location** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gint _tmp25__length2 = 0;
	guint _tmp26_ = 0U;
	guint _tmp27_ = 0U;
	Location* _tmp28_ = NULL;
	gboolean _tmp29_ = FALSE;
#line 257 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->locations;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->cleared;
#line 260 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp4_) {
#line 261 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 1214 "minefield.c"
	}
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp5_ = self->locations;
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp5__length1 = self->locations_length1;
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp5__length2 = self->locations_length2;
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp6_ = x;
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp7_ = y;
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp8_ = _tmp5_[(_tmp6_ * _tmp5__length2) + _tmp7_];
#line 263 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp8_->cleared = TRUE;
#line 264 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp9_ = minefield_get_n_cleared (self);
#line 264 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp10_ = _tmp9_;
#line 264 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	minefield_set_n_cleared (self, _tmp10_ + 1);
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp11_ = self->locations;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp11__length1 = self->locations_length1;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp11__length2 = self->locations_length2;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp12_ = x;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp13_ = y;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp14_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp15_ = _tmp14_->flag;
#line 265 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp15_ == FLAG_TYPE_FLAG) {
#line 1252 "minefield.c"
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
#line 266 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp16_ = minefield_get_n_flags (self);
#line 266 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp17_ = _tmp16_;
#line 266 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_n_flags (self, _tmp17_ - 1);
#line 1261 "minefield.c"
	}
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp18_ = self->locations;
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp18__length1 = self->locations_length1;
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp18__length2 = self->locations_length2;
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp19_ = x;
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp20_ = y;
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp21_ = _tmp18_[(_tmp19_ * _tmp18__length2) + _tmp20_];
#line 267 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp21_->flag = FLAG_TYPE_NONE;
#line 268 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp22_ = x;
#line 268 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp23_ = y;
#line 268 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "redraw-sector", _tmp22_, _tmp23_);
#line 269 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "marks-changed");
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25_ = self->locations;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25__length1 = self->locations_length1;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25__length2 = self->locations_length2;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp26_ = x;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp27_ = y;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp28_ = _tmp25_[(_tmp26_ * _tmp25__length2) + _tmp27_];
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp29_ = _tmp28_->has_mine;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (!_tmp29_) {
#line 1301 "minefield.c"
		guint _tmp30_ = 0U;
		guint _tmp31_ = 0U;
		guint _tmp32_ = 0U;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp30_ = x;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp31_ = y;
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp32_ = minefield_get_n_adjacent_mines (self, _tmp30_, _tmp31_);
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp24_ = _tmp32_ == ((guint) 0);
#line 1313 "minefield.c"
	} else {
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp24_ = FALSE;
#line 1317 "minefield.c"
	}
#line 272 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp24_) {
#line 1321 "minefield.c"
		{
			Neighbour* neighbour_collection = NULL;
			gint neighbour_collection_length1 = 0;
			gint _neighbour_collection_size_ = 0;
			gint neighbour_it = 0;
#line 274 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour_collection = neighbour_map;
#line 274 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 274 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1333 "minefield.c"
				Neighbour neighbour = {0};
#line 274 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				neighbour = neighbour_collection[neighbour_it];
#line 1337 "minefield.c"
				{
					gint nx = 0;
					guint _tmp33_ = 0U;
					Neighbour _tmp34_ = {0};
					gint _tmp35_ = 0;
					gint ny = 0;
					guint _tmp36_ = 0U;
					Neighbour _tmp37_ = {0};
					gint _tmp38_ = 0;
					gint _tmp39_ = 0;
					gint _tmp40_ = 0;
					gboolean _tmp41_ = FALSE;
#line 276 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp33_ = x;
#line 276 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp34_ = neighbour;
#line 276 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp35_ = _tmp34_.x;
#line 276 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					nx = ((gint) _tmp33_) + _tmp35_;
#line 277 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp36_ = y;
#line 277 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp37_ = neighbour;
#line 277 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp38_ = _tmp37_.y;
#line 277 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					ny = ((gint) _tmp36_) + _tmp38_;
#line 278 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp39_ = nx;
#line 278 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp40_ = ny;
#line 278 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp41_ = minefield_is_location (self, _tmp39_, _tmp40_);
#line 278 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					if (_tmp41_) {
#line 1374 "minefield.c"
						gint _tmp42_ = 0;
						gint _tmp43_ = 0;
#line 279 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp42_ = nx;
#line 279 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp43_ = ny;
#line 279 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						minefield_clear_mines_recursive (self, (guint) _tmp42_, (guint) _tmp43_);
#line 1383 "minefield.c"
					}
				}
			}
		}
	}
}


void minefield_set_flag (Minefield* self, guint x, guint y, FlagType flag) {
	gboolean _tmp0_ = FALSE;
	Location** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gint _tmp1__length2 = 0;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	Location* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	FlagType _tmp12_ = 0;
	Location** _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	gint _tmp22__length2 = 0;
	guint _tmp23_ = 0U;
	guint _tmp24_ = 0U;
	Location* _tmp25_ = NULL;
	FlagType _tmp26_ = 0;
	guint _tmp27_ = 0U;
	guint _tmp28_ = 0U;
#line 284 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = self->locations;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1__length1 = self->locations_length1;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1__length2 = self->locations_length2;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = x;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = y;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp1_[(_tmp2_ * _tmp1__length2) + _tmp3_];
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp5_ = _tmp4_->cleared;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp5_) {
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = TRUE;
#line 1431 "minefield.c"
	} else {
		Location** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		gint _tmp6__length2 = 0;
		guint _tmp7_ = 0U;
		guint _tmp8_ = 0U;
		Location* _tmp9_ = NULL;
		FlagType _tmp10_ = 0;
		FlagType _tmp11_ = 0;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = self->locations;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6__length1 = self->locations_length1;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6__length2 = self->locations_length2;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp7_ = x;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp8_ = y;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp10_ = _tmp9_->flag;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp11_ = flag;
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp10_ == _tmp11_;
#line 1459 "minefield.c"
	}
#line 286 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 287 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 1465 "minefield.c"
	}
#line 289 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp12_ = flag;
#line 289 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp12_ == FLAG_TYPE_FLAG) {
#line 1471 "minefield.c"
		guint _tmp13_ = 0U;
		guint _tmp14_ = 0U;
#line 290 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp13_ = minefield_get_n_flags (self);
#line 290 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp14_ = _tmp13_;
#line 290 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_n_flags (self, _tmp14_ + 1);
#line 1480 "minefield.c"
	} else {
		Location** _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		gint _tmp15__length2 = 0;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		Location* _tmp18_ = NULL;
		FlagType _tmp19_ = 0;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp15_ = self->locations;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp15__length1 = self->locations_length1;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp15__length2 = self->locations_length2;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp16_ = x;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp17_ = y;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp18_ = _tmp15_[(_tmp16_ * _tmp15__length2) + _tmp17_];
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp19_ = _tmp18_->flag;
#line 291 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (_tmp19_ == FLAG_TYPE_FLAG) {
#line 1505 "minefield.c"
			guint _tmp20_ = 0U;
			guint _tmp21_ = 0U;
#line 292 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp20_ = minefield_get_n_flags (self);
#line 292 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp21_ = _tmp20_;
#line 292 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			minefield_set_n_flags (self, _tmp21_ - 1);
#line 1514 "minefield.c"
		}
	}
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp22_ = self->locations;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp22__length1 = self->locations_length1;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp22__length2 = self->locations_length2;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp23_ = x;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp24_ = y;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25_ = _tmp22_[(_tmp23_ * _tmp22__length2) + _tmp24_];
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp26_ = flag;
#line 294 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp25_->flag = _tmp26_;
#line 295 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp27_ = x;
#line 295 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp28_ = y;
#line 295 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "redraw-sector", _tmp27_, _tmp28_);
#line 296 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "marks-changed");
#line 1541 "minefield.c"
}


FlagType minefield_get_flag (Minefield* self, guint x, guint y) {
	FlagType result = 0;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	FlagType _tmp4_ = 0;
#line 300 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->locations;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->flag;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 302 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 1574 "minefield.c"
}


guint minefield_get_n_adjacent_mines (Minefield* self, guint x, guint y) {
	guint result = 0U;
	guint n = 0U;
#line 305 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 307 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n = (guint) 0;
#line 1585 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 308 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 308 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 308 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1597 "minefield.c"
			Neighbour neighbour = {0};
#line 308 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1601 "minefield.c"
			{
				gint nx = 0;
				guint _tmp0_ = 0U;
				Neighbour _tmp1_ = {0};
				gint _tmp2_ = 0;
				gint ny = 0;
				guint _tmp3_ = 0U;
				Neighbour _tmp4_ = {0};
				gint _tmp5_ = 0;
				gboolean _tmp6_ = FALSE;
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				gboolean _tmp9_ = FALSE;
#line 310 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp0_ = x;
#line 310 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp1_ = neighbour;
#line 310 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp2_ = _tmp1_.x;
#line 310 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp0_) + _tmp2_;
#line 311 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp3_ = y;
#line 311 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp4_ = neighbour;
#line 311 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp5_ = _tmp4_.y;
#line 311 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp3_) + _tmp5_;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp7_ = nx;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp8_ = ny;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp9_ = minefield_is_location (self, _tmp7_, _tmp8_);
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp9_) {
#line 1639 "minefield.c"
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					gboolean _tmp12_ = FALSE;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp10_ = nx;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp11_ = ny;
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp12_ = minefield_has_mine (self, (guint) _tmp10_, (guint) _tmp11_);
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp6_ = _tmp12_;
#line 1651 "minefield.c"
				} else {
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp6_ = FALSE;
#line 1655 "minefield.c"
				}
#line 312 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp6_) {
#line 1659 "minefield.c"
					guint _tmp13_ = 0U;
#line 313 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp13_ = n;
#line 313 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					n = _tmp13_ + 1;
#line 1665 "minefield.c"
				}
			}
		}
	}
#line 315 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = n;
#line 315 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 1674 "minefield.c"
}


gboolean minefield_has_flag_warning (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint _tmp20_ = 0U;
	guint _tmp21_ = 0U;
#line 318 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 320 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = x;
#line 320 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = y;
#line 320 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = minefield_is_cleared (self, _tmp0_, _tmp1_);
#line 320 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (!_tmp2_) {
#line 321 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		result = FALSE;
#line 321 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return result;
#line 1701 "minefield.c"
	}
#line 323 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n_mines = (guint) 0;
#line 323 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	n_flags = (guint) 0;
#line 1707 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 324 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 324 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 324 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1719 "minefield.c"
			Neighbour neighbour = {0};
#line 324 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1723 "minefield.c"
			{
				gint nx = 0;
				guint _tmp3_ = 0U;
				Neighbour _tmp4_ = {0};
				gint _tmp5_ = 0;
				gint ny = 0;
				guint _tmp6_ = 0U;
				Neighbour _tmp7_ = {0};
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gboolean _tmp11_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gboolean _tmp14_ = FALSE;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				FlagType _tmp18_ = 0;
#line 326 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp3_ = x;
#line 326 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp4_ = neighbour;
#line 326 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp5_ = _tmp4_.x;
#line 326 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp3_) + _tmp5_;
#line 327 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp6_ = y;
#line 327 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp7_ = neighbour;
#line 327 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp8_ = _tmp7_.y;
#line 327 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp6_) + _tmp8_;
#line 328 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp9_ = nx;
#line 328 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp10_ = ny;
#line 328 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp11_ = minefield_is_location (self, _tmp9_, _tmp10_);
#line 328 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp11_) {
#line 329 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					continue;
#line 1768 "minefield.c"
				}
#line 330 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp12_ = nx;
#line 330 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp13_ = ny;
#line 330 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp14_ = minefield_has_mine (self, (guint) _tmp12_, (guint) _tmp13_);
#line 330 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp14_) {
#line 1778 "minefield.c"
					guint _tmp15_ = 0U;
#line 331 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp15_ = n_mines;
#line 331 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					n_mines = _tmp15_ + 1;
#line 1784 "minefield.c"
				}
#line 332 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp16_ = nx;
#line 332 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp17_ = ny;
#line 332 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp18_ = minefield_get_flag (self, (guint) _tmp16_, (guint) _tmp17_);
#line 332 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp18_ == FLAG_TYPE_FLAG) {
#line 1794 "minefield.c"
					guint _tmp19_ = 0U;
#line 333 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp19_ = n_flags;
#line 333 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					n_flags = _tmp19_ + 1;
#line 1800 "minefield.c"
				}
			}
		}
	}
#line 336 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp20_ = n_flags;
#line 336 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp21_ = n_mines;
#line 336 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp20_ > _tmp21_;
#line 336 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 1813 "minefield.c"
}


static void minefield_place_mines (Minefield* self, guint x, guint y) {
#line 340 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 1820 "minefield.c"
	{
		gint n = 0;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		n = 0;
#line 1825 "minefield.c"
		{
			gboolean _tmp0_ = FALSE;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp0_ = TRUE;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			while (TRUE) {
#line 1832 "minefield.c"
				gint _tmp1_ = 0;
				guint _tmp2_ = 0U;
				gint32 rx = 0;
				guint _tmp3_ = 0U;
				gint32 _tmp4_ = 0;
				gint32 ry = 0;
				guint _tmp5_ = 0U;
				gint32 _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
				gint32 _tmp8_ = 0;
				guint _tmp9_ = 0U;
				Location** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gint _tmp12__length2 = 0;
				gint32 _tmp13_ = 0;
				gint32 _tmp14_ = 0;
				Location* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp0_) {
#line 1853 "minefield.c"
				}
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp0_ = FALSE;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp1_ = n;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp2_ = self->n_mines;
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!(((guint) _tmp1_) < _tmp2_)) {
#line 342 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					break;
#line 1865 "minefield.c"
				}
#line 344 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp3_ = self->width;
#line 344 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp4_ = g_random_int_range ((gint32) 0, (gint32) _tmp3_);
#line 344 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				rx = _tmp4_;
#line 345 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp5_ = self->height;
#line 345 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp6_ = g_random_int_range ((gint32) 0, (gint32) _tmp5_);
#line 345 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				ry = _tmp6_;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp8_ = rx;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp9_ = x;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (((guint) _tmp8_) == _tmp9_) {
#line 1885 "minefield.c"
					gint32 _tmp10_ = 0;
					guint _tmp11_ = 0U;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp10_ = ry;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp11_ = y;
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp7_ = ((guint) _tmp10_) == _tmp11_;
#line 1894 "minefield.c"
				} else {
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp7_ = FALSE;
#line 1898 "minefield.c"
				}
#line 347 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (_tmp7_) {
#line 348 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					continue;
#line 1904 "minefield.c"
				}
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp12_ = self->locations;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp12__length1 = self->locations_length1;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp12__length2 = self->locations_length2;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp13_ = rx;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp14_ = ry;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				_tmp16_ = _tmp15_->has_mine;
#line 350 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
				if (!_tmp16_) {
#line 1922 "minefield.c"
					gboolean adj_found = FALSE;
					gboolean _tmp26_ = FALSE;
#line 352 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					adj_found = FALSE;
#line 1927 "minefield.c"
					{
						Neighbour* neighbour_collection = NULL;
						gint neighbour_collection_length1 = 0;
						gint _neighbour_collection_size_ = 0;
						gint neighbour_it = 0;
#line 354 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						neighbour_collection = neighbour_map;
#line 354 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 354 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1939 "minefield.c"
							Neighbour neighbour = {0};
#line 354 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
							neighbour = neighbour_collection[neighbour_it];
#line 1943 "minefield.c"
							{
								gboolean _tmp17_ = FALSE;
								gint32 _tmp18_ = 0;
								guint _tmp19_ = 0U;
								Neighbour _tmp20_ = {0};
								gint _tmp21_ = 0;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp18_ = rx;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp19_ = x;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp20_ = neighbour;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								_tmp21_ = _tmp20_.x;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								if (((guint) _tmp18_) == (_tmp19_ + _tmp21_)) {
#line 1960 "minefield.c"
									gint32 _tmp22_ = 0;
									guint _tmp23_ = 0U;
									Neighbour _tmp24_ = {0};
									gint _tmp25_ = 0;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp22_ = ry;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp23_ = y;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp24_ = neighbour;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp25_ = _tmp24_.y;
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp17_ = ((guint) _tmp22_) == (_tmp23_ + _tmp25_);
#line 1975 "minefield.c"
								} else {
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									_tmp17_ = FALSE;
#line 1979 "minefield.c"
								}
#line 356 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
								if (_tmp17_) {
#line 358 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									adj_found = TRUE;
#line 359 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
									break;
#line 1987 "minefield.c"
								}
							}
						}
					}
#line 363 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					_tmp26_ = adj_found;
#line 363 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
					if (!_tmp26_) {
#line 1996 "minefield.c"
						Location** _tmp27_ = NULL;
						gint _tmp27__length1 = 0;
						gint _tmp27__length2 = 0;
						gint32 _tmp28_ = 0;
						gint32 _tmp29_ = 0;
						Location* _tmp30_ = NULL;
						gint _tmp31_ = 0;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp27_ = self->locations;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp27__length1 = self->locations_length1;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp27__length2 = self->locations_length2;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp28_ = rx;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp29_ = ry;
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp30_ = _tmp27_[(_tmp28_ * _tmp27__length2) + _tmp29_];
#line 365 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp30_->has_mine = TRUE;
#line 366 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						_tmp31_ = n;
#line 366 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
						n = _tmp31_ + 1;
#line 2022 "minefield.c"
					}
				}
			}
		}
	}
}


static gboolean _minefield_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = minefield_timeout_cb ((Minefield*) self);
#line 377 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2036 "minefield.c"
}


static void minefield_start_timer (Minefield* self) {
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
#line 372 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 374 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock_timeout;
#line 374 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 2049 "minefield.c"
		guint _tmp1_ = 0U;
#line 375 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp1_ = self->priv->clock_timeout;
#line 375 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_source_remove (_tmp1_);
#line 2055 "minefield.c"
	}
#line 376 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 377 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _minefield_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 377 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->clock_timeout = _tmp2_;
#line 2063 "minefield.c"
}


static void minefield_start_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
#line 380 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 382 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 382 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 2075 "minefield.c"
		GTimer* _tmp1_ = NULL;
#line 383 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 383 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 383 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 2083 "minefield.c"
	}
#line 384 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "clock-started");
#line 385 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 386 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	minefield_start_timer (self);
#line 2091 "minefield.c"
}


static void minefield_stop_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	GTimer* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	guint _tmp4_ = 0U;
	GTimer* _tmp6_ = NULL;
#line 389 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 391 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 391 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 392 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 2110 "minefield.c"
	}
#line 393 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = self->priv->clock_elapsed;
#line 393 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = self->priv->clock;
#line 393 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 393 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->clock_elapsed = _tmp1_ + _tmp3_;
#line 394 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = self->priv->clock_timeout;
#line 394 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp4_ != ((guint) 0)) {
#line 2124 "minefield.c"
		guint _tmp5_ = 0U;
#line 395 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp5_ = self->priv->clock_timeout;
#line 395 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_source_remove (_tmp5_);
#line 2130 "minefield.c"
	}
#line 396 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 397 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp6_ = self->priv->clock;
#line 397 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_timer_stop (_tmp6_);
#line 398 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 398 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->clock = NULL;
#line 399 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 2144 "minefield.c"
}


static void minefield_continue_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
#line 402 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 404 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 404 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 2156 "minefield.c"
		GTimer* _tmp1_ = NULL;
#line 405 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 405 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 405 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 2164 "minefield.c"
	} else {
		GTimer* _tmp2_ = NULL;
#line 407 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 407 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_timer_continue (_tmp2_);
#line 2171 "minefield.c"
	}
#line 408 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 409 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	minefield_start_timer (self);
#line 2177 "minefield.c"
}


static gboolean minefield_timeout_cb (Minefield* self) {
	gboolean result = FALSE;
#line 412 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 414 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 415 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = TRUE;
#line 415 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2191 "minefield.c"
}


guint minefield_get_n_cleared (Minefield* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_n_cleared;
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2206 "minefield.c"
}


void minefield_set_n_cleared (Minefield* self, guint value) {
	guint _tmp0_ = 0U;
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = value;
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_n_cleared = _tmp0_;
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_notify ((GObject *) self, "n-cleared");
#line 2220 "minefield.c"
}


gboolean minefield_get_is_complete (Minefield* self) {
	gboolean result;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	guint _tmp4_ = 0U;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = minefield_get_n_cleared (self);
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = self->width;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp3_ = self->height;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = self->n_mines;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp1_ == ((_tmp2_ * _tmp3_) - _tmp4_);
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2247 "minefield.c"
}


guint minefield_get_n_flags (Minefield* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_n_flags;
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2262 "minefield.c"
}


void minefield_set_n_flags (Minefield* self, guint value) {
	guint _tmp0_ = 0U;
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = value;
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_n_flags = _tmp0_;
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_notify ((GObject *) self, "n-flags");
#line 2276 "minefield.c"
}


gboolean minefield_get_use_autoflag (Minefield* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->_use_autoflag;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2291 "minefield.c"
}


void minefield_set_use_autoflag (Minefield* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = value;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->_use_autoflag = _tmp0_;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_notify ((GObject *) self, "use-autoflag");
#line 2305 "minefield.c"
}


gdouble minefield_get_elapsed (Minefield* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	GTimer* _tmp1_ = NULL;
	gdouble _tmp4_ = 0.0;
#line 102 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = self->priv->clock;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp1_ == NULL) {
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = 0.0;
#line 2322 "minefield.c"
	} else {
		GTimer* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp3_;
#line 2332 "minefield.c"
	}
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp4_ = self->priv->clock_elapsed;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp4_ + _tmp0_;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2340 "minefield.c"
}


gboolean minefield_get_paused (Minefield* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_paused;
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	return result;
#line 2355 "minefield.c"
}


void minefield_set_paused (Minefield* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp10_ = FALSE;
#line 111 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp1_ = minefield_get_is_complete (self);
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp2_ = _tmp1_;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp2_) {
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = TRUE;
#line 2376 "minefield.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp3_ = self->exploded;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp3_;
#line 2383 "minefield.c"
	}
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		return;
#line 2389 "minefield.c"
	}
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp5_ = value;
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp5_) {
#line 2395 "minefield.c"
		gboolean _tmp6_ = FALSE;
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp6_ = self->priv->_paused;
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp4_ = !_tmp6_;
#line 2401 "minefield.c"
	} else {
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp4_ = FALSE;
#line 2405 "minefield.c"
	}
#line 116 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (_tmp4_) {
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_stop_clock (self);
#line 2411 "minefield.c"
	} else {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		_tmp8_ = value;
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (!_tmp8_) {
#line 2419 "minefield.c"
			gboolean _tmp9_ = FALSE;
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp9_ = self->priv->_paused;
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp7_ = _tmp9_;
#line 2425 "minefield.c"
		} else {
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			_tmp7_ = FALSE;
#line 2429 "minefield.c"
		}
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		if (_tmp7_) {
#line 119 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
			minefield_continue_clock (self);
#line 2435 "minefield.c"
		}
	}
#line 121 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_tmp10_ = value;
#line 121 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_paused = _tmp10_;
#line 122 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "paused-changed");
#line 111 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_notify ((GObject *) self, "paused");
#line 2446 "minefield.c"
}


static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_return_if_fail (n_param_values == 3);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		data1 = closure->data;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		data2 = param_values->data[0].v_pointer;
#line 2465 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		data1 = param_values->data[0].v_pointer;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		data2 = closure->data;
#line 2471 "minefield.c"
	}
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 2477 "minefield.c"
}


static void minefield_class_init (MinefieldClass * klass) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	minefield_parent_class = g_type_class_peek_parent (klass);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_type_class_add_private (klass, sizeof (MinefieldPrivate));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_minefield_get_property;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_minefield_set_property;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = minefield_finalize;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_CLEARED, g_param_spec_uint ("n-cleared", "n-cleared", "n-cleared", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_IS_COMPLETE, g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_FLAGS, g_param_spec_uint ("n-flags", "n-flags", "n-flags", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_USE_AUTOFLAG, g_param_spec_boolean ("use-autoflag", "use-autoflag", "use-autoflag", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_ELAPSED, g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_PAUSED, g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("clock_started", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("paused_changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("tick", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("redraw_sector", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("marks_changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("explode", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	g_signal_new ("cleared", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2518 "minefield.c"
}


static void minefield_instance_init (Minefield * self) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv = MINEFIELD_GET_PRIVATE (self);
#line 51 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->width = (guint) 0;
#line 52 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->height = (guint) 0;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->n_mines = (guint) 0;
#line 61 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->exploded = FALSE;
#line 64 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->placed_mines = FALSE;
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_n_cleared = (guint) 0;
#line 68 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_n_flags = (guint) 0;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->priv->_paused = FALSE;
#line 2541 "minefield.c"
}


static void minefield_finalize (GObject* obj) {
	Minefield * self;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINEFIELD, Minefield);
#line 58 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 97 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	G_OBJECT_CLASS (minefield_parent_class)->finalize (obj);
#line 2555 "minefield.c"
}


GType minefield_get_type (void) {
	static volatile gsize minefield_type_id__volatile = 0;
	if (g_once_init_enter (&minefield_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MinefieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minefield_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Minefield), 0, (GInstanceInitFunc) minefield_instance_init, NULL };
		GType minefield_type_id;
		minefield_type_id = g_type_register_static (G_TYPE_OBJECT, "Minefield", &g_define_type_info, 0);
		g_once_init_leave (&minefield_type_id__volatile, minefield_type_id);
	}
	return minefield_type_id__volatile;
}


static void _vala_minefield_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	switch (property_id) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_N_CLEARED:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_cleared (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_IS_COMPLETE:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_boolean (value, minefield_get_is_complete (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_N_FLAGS:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_flags (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_boolean (value, minefield_get_use_autoflag (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_ELAPSED:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_double (value, minefield_get_elapsed (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_PAUSED:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		g_value_set_boolean (value, minefield_get_paused (self));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 2612 "minefield.c"
		default:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 2618 "minefield.c"
	}
}


static void _vala_minefield_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
	switch (property_id) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_N_CLEARED:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_n_cleared (self, g_value_get_uint (value));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_N_FLAGS:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_n_flags (self, g_value_get_uint (value));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_use_autoflag (self, g_value_get_boolean (value));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		case MINEFIELD_PAUSED:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		minefield_set_paused (self, g_value_get_boolean (value));
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 2652 "minefield.c"
		default:
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-mines/src/minefield.vala"
		break;
#line 2658 "minefield.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



